// F75111_DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "F75111_DIO.h"
#include "F75111_DIODlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WDT_TIMER_ENABLE	1
#define WDT_LOOP_TIMER_ENABLE 2

#define WM_SHOWTASK (WM_USER+100)

F75111_Address m_F75111;

#define dwDioSet1Vacant 0x0F/*00001111*/
#define dwDioSet2Vacant 0xF0/*11110000*/
#define dwDio0 0x01/*0x00000001*/
#define dwDio1 0x02/*0x00000010*/
#define dwDio2 0x04/*0x00000100*/
#define dwDio3 0x08/*0x00001000*/
#define dwDio4 0x10/*0x00010000*/
#define dwDio5 0x20/*0x00100000*/
#define dwDio6 0x40/*0x01000000*/
#define dwDio7 0x80/*0x10000000*/

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CF75111_DIODlg dialog

CF75111_DIODlg::CF75111_DIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CF75111_DIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CF75111_DIODlg)
	m_WDT_Timer = 10;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CF75111_DIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CF75111_DIODlg)
	DDX_Control(pDX, IDC_PermanentWDT, m_CHECK_PermanentWDT);
	DDX_Control(pDX, IDC_EnableLoop, m_CHECK_EnableLoop);
	DDX_Control(pDX, IDC_ENABLE_WDT, m_BTN_Enable_WDT);
	DDX_Control(pDX, IDC_PROGRESS_DIO_2, m_Progress_2);
	DDX_Control(pDX, IDC_PROGRESS_DIO_1, m_Progress_1);
	DDX_Text(pDX, IDC_WDT_TIMER, m_WDT_Timer);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_PROGRESS_DIO_3, m_Progress_4);
	DDX_Control(pDX, IDC_PROGRESS_DIO_4, m_Progress_3);
}

BEGIN_MESSAGE_MAP(CF75111_DIODlg, CDialog)
	//{{AFX_MSG_MAP(CF75111_DIODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_DIO, OnCheckDio)
	ON_BN_CLICKED(IDC_ENABLE_WDT, OnEnableWdt)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_EnableLoop, OnEnableLoop)
	ON_BN_CLICKED(IDC_PermanentWDT, OnPermanentWDT)
	ON_BN_CLICKED(IDC_DISABLE_WDT, OnDisableWdt)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SHOWTASK,OnShowTask)
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CF75111_DIODlg message handlers

BOOL CF75111_DIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	if(!InitializeWinIo())
		AfxMessageBox("Initialize Fail!!");

	CreateTrayIcon(1);

	m_IsWDTEnable = FALSE;
	m_IsF75111 = FALSE;
	m_IsWDTLoop   = FALSE;
	m_IsPermanent = FALSE ;

	GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);

	::F75111_Init();

	if(m_TwoDio)
	{
		GetDlgItem(IDC_STATIC_ADDRESS2)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_ADDRESS2)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_DIO2_HI)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_DIO2_LOW)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_DO2)->EnableWindow(TRUE);
		GetDlgItem(IDC_STATIC_DI2)->EnableWindow(TRUE);
		((CStatic *)GetDlgItem(IDC_LED_DIO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DIO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		GetDlgItem(IDC_PROGRESS_DIO_3)->EnableWindow(TRUE);
		GetDlgItem(IDC_PROGRESS_DIO_4)->EnableWindow(TRUE);
		((CStatic *)GetDlgItem(IDC_LED_DO2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	}


	CString szPath;
	FILE* pfile;
	szPath.Format("c:/WINDOWS/");

	if((pfile = fopen(szPath+DEFAULT_PATH,"r")) == NULL)
	{
		SetDlgItemText(IDC_EDIT_ADDRESS, "9C");
		if(m_TwoDio)
			SetDlgItemText(IDC_EDIT_ADDRESS2, "6E");
		SetDlgItemText(IDC_WDT_TIMER, "10");
	}
	else
	{
		FileOpen(szPath+DEFAULT_PATH);
		fclose(pfile);
		ShowWindow(SW_HIDE);
	}


	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CF75111_DIODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CF75111_DIODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		

		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting

		CRect rect;
		this->GetClientRect(rect);
		dc.FillSolidRect(rect,RGB(255,255,255));
	
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CF75111_DIODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

HBRUSH CF75111_DIODlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	if(nCtlColor == CTLCOLOR_STATIC)
	{
		pDC->SetBkMode(TRANSPARENT);
		hbr = (HBRUSH)GetStockObject( 0 );
	}
	else
	{
		hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	}
	// TODO: Return a different brush if the default is not desired
	return hbr;

}

void CF75111_DIODlg::OnTimer(UINT nIDEvent) 
{
	CString strTmp;

	CDialog::OnTimer(nIDEvent);
	switch(nIDEvent)
	{
		case WDT_TIMER_ENABLE:
			if(m_CountDown >= 1)
			{
				this->m_CountDown = this->m_CountDown -1 ;
	
				strTmp.Format("Reboot after %d secords",this->m_CountDown);		
				SetDlgItemText(IDC_STATIC_STATUS,strTmp);
			}
			else
			{
				GetDlgItem(IDC_WDT_TIMER)->EnableWindow(TRUE);
				GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
				KillTimer(WDT_TIMER_ENABLE);
			}
		break;
		
		case WDT_LOOP_TIMER_ENABLE:
			if(m_CountDown >= 2)
			{
				this->m_CountDown = this->m_CountDown -1 ;
				strTmp.Format("Reboot after %d secord(s)",this->m_CountDown);		
				SetDlgItemText(IDC_STATIC_STATUS,strTmp);
			}
			else
			{
				::F75111_SetWDTDisable();
				SetDlgItemText(IDC_STATIC_STATUS,"WDT got DISABLE signal");			// setting the status static

				Sleep(1000);
				this->m_CountDown = this->m_WDT_Timer;
				::F75111_SetWDTEnable(m_CountDown);

				strTmp.Format("Reboot after %d secord(s)",this->m_CountDown);		
				SetDlgItemText(IDC_STATIC_STATUS,strTmp);
			}
		break;
	}
}

void CF75111_DIODlg::OnCheckDio() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString tmp,tmp1;

	// change all setting value to default
	((CStatic *)GetDlgItem(IDC_LED_DI_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DI_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DO_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	if(m_TwoDio)
	{
		((CStatic *)GetDlgItem(IDC_LED_DI2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DI2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DO2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	}

	// change all setting value to default
	this->m_Progress_1.SetPos(0);
	this->m_Progress_2.SetPos(0);
	this->m_Progress_3.SetPos(0);
	this->m_Progress_4.SetPos(0);

	// change all setting value to default
	((CStatic *)GetDlgItem(IDC_LED_DIO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	((CStatic *)GetDlgItem(IDC_LED_DIO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	if(m_TwoDio)
	{
		((CStatic *)GetDlgItem(IDC_LED_DIO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
		((CStatic *)GetDlgItem(IDC_LED_DIO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GRAY)));
	}

	
	GetDlgItemText(IDC_EDIT_ADDRESS, tmp);
	m_F75111.bAddress = this->StringToByte(tmp);

	if(::F75111_Init())
	{	
		m_IsF75111 = TRUE;
		if(this->CheckDIO_2())
			((CStatic *)GetDlgItem(IDC_LED_DIO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
		else
			((CStatic *)GetDlgItem(IDC_LED_DIO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

		if(this->CheckDIO_1())
			((CStatic *)GetDlgItem(IDC_LED_DIO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
		else
			((CStatic *)GetDlgItem(IDC_LED_DIO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

		this->DIO_Write(0);		//low^w]
	}
	else
	{
		AfxMessageBox("Initial F75111_1 fail!!");
	}

	GetDlgItemText(IDC_EDIT_ADDRESS2, tmp1);
	m_F75111.bAddress = this->StringToByte(tmp1);
	if(m_TwoDio)
	{
		if(::F75111_Init())
		{	
			m_IsF75111 = TRUE;
			if(this->CheckDIO_4())
				((CStatic *)GetDlgItem(IDC_LED_DIO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
			else
				((CStatic *)GetDlgItem(IDC_LED_DIO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if(this->CheckDIO_3())
				((CStatic *)GetDlgItem(IDC_LED_DIO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
			else
				((CStatic *)GetDlgItem(IDC_LED_DIO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			this->DIO_Write(0);		//low^w]
		}
		else
		{
			AfxMessageBox("Initial F75111_2 fail!!");
		}
	}

}

void CF75111_DIODlg::DIO_Write(BYTE dwDataVal)
{
	if(m_IsF75111)
		::F75111_SetDigitalOutput(dwDataVal);
}

BYTE CF75111_DIODlg::DIO_Read()
{
	if(m_IsF75111)
		return ::F75111_GetDigitalInput();
	else
		return -1;
}

BOOL CF75111_DIODlg::CheckDIO_1()
{
	int  dwRead;
	CString tmp;
	int dwValueCount = 0;
	int dwReadCount = 0;


	for (int dwValue = 1; dwValue <=8; dwValue=dwValue*2 )
	{
		if (dwValue == dwDio0 || dwValue == dwDio1 || dwValue == dwDio2 || dwValue == dwDio3)
			this->DIO_Write(dwValue);
		
		Sleep(50);
	
		this->m_Progress_1.SetPos(dwValue*14);
	

		if (dwValue == dwDio0 || dwValue == dwDio1 || dwValue == dwDio2 || dwValue == dwDio3)
		{
			dwRead = this->DIO_Read() & 0xFF;

			if ( dwValue == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio1 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio3 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}
			
			if ( dwRead == dwDio0 || dwRead - dwDioSet2Vacant == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==1) ((CStatic *)GetDlgItem(IDC_LED_DI_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio1 || dwRead - dwDioSet2Vacant == dwDio1	 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==2) ((CStatic *)GetDlgItem(IDC_LED_DI_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio2 || dwRead - dwDioSet2Vacant == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==4) ((CStatic *)GetDlgItem(IDC_LED_DI_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead  == dwDio3 || dwRead - dwDioSet2Vacant == dwDio3 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==8) ((CStatic *)GetDlgItem(IDC_LED_DI_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));


		}
		
			//	return FALSE;
			//}
	}
	//}

	//((CStatic *)GetDlgItem(IDC_LED_DO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));

	//((CStatic *)GetDlgItem(IDC_LED_DI_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	if ( dwValueCount != dwReadCount )
		return FALSE;
	else
		return TRUE;
}

BOOL CF75111_DIODlg::CheckDIO_2()
{
	int  dwRead;
	CString tmp;
	int dwValueCount = 0;
	int dwReadCount = 0;

	for (int dwValue = 1; dwValue <=8; dwValue=dwValue*2)
	{
		if (dwValue == 1 || dwValue == 2 || dwValue == 4 || dwValue == 8)
			this->DIO_Write(dwValue*16);
		
		this->m_Progress_2.SetPos(dwValue*14);

		Sleep(50);

		if (dwValue == 1 || dwValue == 2 || dwValue == 4 || dwValue == 8)
		{
			dwRead = this->DIO_Read() & 0xFF;

			if ( dwValue == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio1 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio3)
			{
				((CStatic *)GetDlgItem(IDC_LED_DO_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}
	
			if ( dwRead == dwDio4 || dwRead - dwDioSet1Vacant == dwDio4 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==1) ((CStatic *)GetDlgItem(IDC_LED_DI_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio5 || dwRead - dwDioSet1Vacant == dwDio5 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==2) ((CStatic *)GetDlgItem(IDC_LED_DI_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio6 || dwRead - dwDioSet1Vacant == dwDio6 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==4) ((CStatic *)GetDlgItem(IDC_LED_DI_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio7 || dwRead - dwDioSet1Vacant == dwDio7 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==8) ((CStatic *)GetDlgItem(IDC_LED_DI_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

		}
			//	return FALSE;
			//}
		//}
	}
	if ( dwValueCount != dwReadCount )
		return FALSE;
	else
		return TRUE;
	//}

	//((CStatic *)GetDlgItem(IDC_LED_DO_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));

	//((CStatic *)GetDlgItem(IDC_LED_DI_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//
	//return TRUE;
}
BOOL CF75111_DIODlg::CheckDIO_3()
{
	int  dwRead;
	CString tmp;
	int dwValueCount = 0;
	int dwReadCount = 0;


	for (int dwValue = 1; dwValue <=8; dwValue=dwValue*2 )
	{
		if (dwValue == dwDio0 || dwValue == dwDio1 || dwValue == dwDio2 || dwValue == dwDio3)
			this->DIO_Write(dwValue);
		
		Sleep(50);
	
		this->m_Progress_3.SetPos(dwValue*14);
	

		if (dwValue == dwDio0 || dwValue == dwDio1 || dwValue == dwDio2 || dwValue == dwDio3)
		{
			dwRead = this->DIO_Read() & 0xFF;

			if ( dwValue == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio1 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio3 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}
			
			if ( dwRead == dwDio0 || dwRead - dwDioSet2Vacant == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==1) ((CStatic *)GetDlgItem(IDC_LED_DI2_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio1 || dwRead - dwDioSet2Vacant == dwDio1	 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==2) ((CStatic *)GetDlgItem(IDC_LED_DI2_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio2 || dwRead - dwDioSet2Vacant == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==4) ((CStatic *)GetDlgItem(IDC_LED_DI2_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead  == dwDio3 || dwRead - dwDioSet2Vacant == dwDio3 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==8) ((CStatic *)GetDlgItem(IDC_LED_DI2_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));


		}
		
			//	return FALSE;
			//}
	}
	//}

	//((CStatic *)GetDlgItem(IDC_LED_DO_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));

	//((CStatic *)GetDlgItem(IDC_LED_DI_3))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_2))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_1))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_0))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	if ( dwValueCount != dwReadCount )
		return FALSE;
	else
		return TRUE;
}

BOOL CF75111_DIODlg::CheckDIO_4()
{
	int  dwRead;
	CString tmp;
	int dwValueCount = 0;
	int dwReadCount = 0;

	for (int dwValue = 1; dwValue <=8; dwValue=dwValue*2)
	{
		if (dwValue == 1 || dwValue == 2 || dwValue == 4 || dwValue == 8)
			this->DIO_Write(dwValue*16);
		
		this->m_Progress_4.SetPos(dwValue*14);

		Sleep(50);

		if (dwValue == 1 || dwValue == 2 || dwValue == 4 || dwValue == 8)
		{
			dwRead = this->DIO_Read() & 0xFF;

			if ( dwValue == dwDio0 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio1 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio2 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}

			if ( dwValue == dwDio3)
			{
				((CStatic *)GetDlgItem(IDC_LED_DO2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwValueCount++;
			}
	
			if ( dwRead == dwDio4 || dwRead - dwDioSet1Vacant == dwDio4 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==1) ((CStatic *)GetDlgItem(IDC_LED_DI2_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio5 || dwRead - dwDioSet1Vacant == dwDio5 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==2) ((CStatic *)GetDlgItem(IDC_LED_DI2_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio6 || dwRead - dwDioSet1Vacant == dwDio6 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==4) ((CStatic *)GetDlgItem(IDC_LED_DI2_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

			if ( dwRead == dwDio7 || dwRead - dwDioSet1Vacant == dwDio7 )
			{
				((CStatic *)GetDlgItem(IDC_LED_DI2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
				dwReadCount++;
			}else if(dwValue==8) ((CStatic *)GetDlgItem(IDC_LED_DI2_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_RED)));

		}
			//	return FALSE;
			//}
		//}
	}
	if ( dwValueCount != dwReadCount )
		return FALSE;
	else
		return TRUE;
	//}

	//((CStatic *)GetDlgItem(IDC_LED_DO_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DO_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));

	//((CStatic *)GetDlgItem(IDC_LED_DI_7))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_6))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_5))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//((CStatic *)GetDlgItem(IDC_LED_DI_4))->SetBitmap(::LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDB_BITMAP_LED_GREEN)));
	//
	//return TRUE;
}

//*******************************************************************************************//
//							start WDT test		 (Loop test)								 //								
//*******************************************************************************************//
void CF75111_DIODlg::OnEnableLoop() 
{
	if(IsDlgButtonChecked(IDC_EnableLoop)== BST_CHECKED)
	{
		m_IsWDTLoop = TRUE;
	}
	else
	{
		m_IsWDTLoop = FALSE;
	}		
}

void CF75111_DIODlg::OnEnableWdt() 
{
	CString strTmp;
	UpdateData(TRUE);
	
	GetDlgItemText(IDC_EDIT_ADDRESS, strTmp);
	m_F75111.bAddress = this->StringToByte(strTmp);

	if(F75111_Init())
	{
		m_IsF75111 = TRUE; 

		if( (this->m_WDT_Timer>255) || (this->m_WDT_Timer<0) )
			SetDlgItemText(IDC_STATIC_STATUS,"Please input the number between 0-255 ");
		else
		{
			if(!m_IsWDTLoop)		// single test
			{
				/***************************************************/
				this->DestroyTrayIcon(1);
				this->CreateTrayIcon(2);
				/***************************************************/
				m_IsWDTEnable = TRUE;
			
				GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(TRUE);
				GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(FALSE);	
				GetDlgItem(IDC_WDT_TIMER)->EnableWindow(FALSE);			// disable the EDITBOX of timer
				GetDlgItem(IDC_EnableLoop)->EnableWindow(FALSE);
				this->m_CountDown = this->m_WDT_Timer;					// get timer 
		
				if(m_IsF75111)
					::F75111_SetWDTEnable(m_CountDown);
		
				SetTimer(WDT_TIMER_ENABLE, 1000, 0);					// start the timer 
			
				strTmp.Format("Reboot After %d secords", m_CountDown);	
				SetDlgItemText(IDC_STATIC_STATUS,strTmp);				// setting the status static
			}
			else				// loop test
			{
				// change icon to verify wdt is running or not => YES 
				this->DestroyTrayIcon(1);
				this->CreateTrayIcon(2);

				GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(TRUE);
				GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(FALSE);
				GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(FALSE);
				GetDlgItem(IDC_WDT_TIMER)->EnableWindow(FALSE);	

				// start timer 
				SetTimer(WDT_LOOP_TIMER_ENABLE, 1000, 0);
	
				// get timer 
				this->m_CountDown = this->m_WDT_Timer;

				// enable WDT
				if(m_IsF75111)
					::F75111_SetWDTEnable(m_CountDown);
			}
		}
	}
	else
	{
		AfxMessageBox("Initial F75111 fail!!");
	}
}

void CF75111_DIODlg::OnDisableWdt() 
{
	if(!m_IsWDTLoop)			// single test
	{
		/***************************************************/
		this->DestroyTrayIcon(2);
		this->CreateTrayIcon(1);
		/***************************************************/
		m_IsWDTEnable = FALSE;				

		if(m_IsF75111)
			::F75111_SetWDTDisable();
										
		KillTimer(WDT_TIMER_ENABLE);							// stop the timer
		
		GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);
		GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
		GetDlgItem(IDC_WDT_TIMER )->EnableWindow(TRUE);			// enable the EDITBOX of timer 
		GetDlgItem(IDC_EnableLoop)->EnableWindow(TRUE);
		SetDlgItemText(IDC_STATIC_STATUS,"WDT got DISABLE signal");			// setting the status static
	}
	else						// loop test
	{
		// change icon to verify wdt is running or not => No
		this->DestroyTrayIcon(2);
		this->CreateTrayIcon(1);
		
		GetDlgItem(IDC_DISABLE_WDT)->EnableWindow(FALSE);
		GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
		GetDlgItem(IDC_ENABLE_WDT)->EnableWindow(TRUE);
		GetDlgItem(IDC_WDT_TIMER)->EnableWindow(TRUE);	

		KillTimer(WDT_LOOP_TIMER_ENABLE);

		if(m_IsF75111)
			::F75111_SetWDTDisable();

		SetDlgItemText(IDC_STATIC_STATUS,"WDT got DISABLE signal");
	}
}

BYTE CF75111_DIODlg::StringToByte(CString strAddress)
{
	int x;
	sscanf(strAddress, "%x ", &x);
	return x ;
}

void CF75111_DIODlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if ( SIZE_MINIMIZED == nType )
		SetVisible(FALSE);
}

void CF75111_DIODlg::SetVisible(BOOL bShow)
{
	m_bShow = bShow;
	if(m_bShow)
	{
		ShowWindow(SW_RESTORE);
		BringWindowToTop();
		SetForegroundWindow();
		SetActiveWindow();
	}
	else
	{
		ShowWindow(SW_HIDE);
	}
}

void CF75111_DIODlg::CreateTrayIcon(int nIcon)
{
	NOTIFYICONDATA nid;
	
	nid.cbSize	= sizeof(nid);
	nid.hWnd	= this->m_hWnd;
	switch (nIcon)
	{
	case 1:
		nid.uID		= IDR_MAINFRAME;
		nid.hIcon	= LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_MAINFRAME)); 
		break;
	case 2:
		nid.uID		= IDR_WDT;
		nid.hIcon	= LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_WDT));
		break;

	default:
		break;
	}
	
	nid.uFlags	= NIF_ICON|NIF_MESSAGE|NIF_TIP;
	nid.uCallbackMessage = WM_SHOWTASK;
	strcpy(nid.szTip, " F75111v2.7w ");

	// Add the notification to the tray.
    Shell_NotifyIcon(NIM_ADD, &nid);
}

void CF75111_DIODlg::DestroyTrayIcon(int nIcon)
{
	NOTIFYICONDATA nid ;
	nid.cbSize = sizeof (nid);					
	nid.hWnd = this->m_hWnd ;					
	
	switch (nIcon)
	{
	case 1:
		nid.uID = IDR_MAINFRAME ;
		break;
	case 2:
		nid.uID = IDR_WDT ;
		break;

	default:
		break;
	}

	Shell_NotifyIcon(NIM_DELETE, &nid);
}

LRESULT CF75111_DIODlg::OnShowTask(WPARAM wParam, LPARAM lParam)
{
	switch(lParam)
	{
	case WM_RBUTTONUP:											// clicked right button
		{
			LPPOINT	lpPoint = new tagPOINT;
			::GetCursorPos(lpPoint);							// get cursor positiion

			CMenu m_Menu;
			m_Menu.CreatePopupMenu();							// create popup menu
			m_Menu.AppendMenu(MF_STRING, WM_DESTROY, "Exit");	// append exit to menu

			m_Menu.TrackPopupMenu(TPM_LEFTALIGN, lpPoint->x, lpPoint->y, this);

			HMENU   hmenu=m_Menu.Detach();   
			m_Menu.DestroyMenu();   
			delete   lpPoint;   
		}
		break;

	case WM_LBUTTONDBLCLK:										// double clicked left button
		{
			SetVisible(TRUE);
		}
		break;
	}

	return 0;
}

void CF75111_DIODlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if(m_IsWDTEnable)
	{
		DestroyTrayIcon(2);
	}
	
	if(m_IsWDTLoop)
	{
		DestroyTrayIcon(2);
	}
	
	if(!m_IsWDTEnable && !m_IsWDTLoop)
	{
		DestroyTrayIcon(1);
	}
	
	ShutdownWinIo();
}



void CF75111_DIODlg::OnPermanentWDT() 
{
	// TODO: Add your control notification handler code here
	char	szFileName[MAX_PATH];
	HKEY	hKey;

	if(!m_IsPermanent)
	{
		::GetModuleFileName(NULL, szFileName, MAX_PATH);
		if(::RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_WRITE, &hKey) == ERROR_SUCCESS)
		{
			if( ::RegSetValueEx(hKey, "F75111v2.7W", NULL, REG_SZ, (const unsigned char*)szFileName, MAX_PATH) != ERROR_SUCCESS )
			{
				::RegCloseKey(hKey);
				m_CHECK_PermanentWDT.SetCheck(0);
				AfxMessageBox("Install failed!");
				return;
			}
			RegCloseKey(hKey);
			AfxMessageBox("Install succeeded");
			SetDlgItemText(IDC_PermanentWDT, _T("Uninstall WDT"));
			m_IsPermanent = TRUE;

			CString szPath;
			szPath.Format("c:/WINDOWS/");
			
			FileSave(szPath+DEFAULT_PATH);
		}
		else
		{
			AfxMessageBox("Install failed!");
			m_CHECK_PermanentWDT.SetCheck(0);
		}
	}
	else
	{
		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Run", NULL, KEY_WRITE, &hKey) == ERROR_SUCCESS)   
		{   
			if ( ERROR_SUCCESS != RegDeleteValue(hKey, _T("F75111v2.7W")) )
			{
				m_CHECK_PermanentWDT.SetCheck(1);

				AfxMessageBox(_T("Uninstall failed!"));
			}
			else
			{
				CString szPath;
				szPath.Format("c:/WINDOWS/");

				if(!DeleteFile(szPath+DEFAULT_PATH))
					AfxMessageBox("Delete Fail",MB_ICONSTOP);

				AfxMessageBox(_T("Uninstall Succeed!"));
				SetDlgItemText(IDC_PermanentWDT, _T("Install WDT"));
				m_IsPermanent = FALSE;
			}
			RegCloseKey(hKey);
		}
		else
		{
			m_CHECK_PermanentWDT.SetCheck(1);
			AfxMessageBox(_T("Uninstall failed!"));
		}
	}
}

void CF75111_DIODlg::FileSave(CString FilePath)
{
	CString bAddress, WDT_timer;
	GetDlgItemText(IDC_EDIT_ADDRESS, bAddress);
	GetDlgItemText(IDC_WDT_TIMER, WDT_timer);

	if(m_IsPermanent)
		WritePrivateProfileString(_T("Permanent")	, _T("install")			,	_T("1")	, (LPCTSTR) FilePath);
	
	WritePrivateProfileString(_T("Permanent")	, _T("WDT Loop")		,	_T("1")		, (LPCTSTR) FilePath);

	WritePrivateProfileString(_T("Information")		, _T("F75111 Address")	,	bAddress	, (LPCTSTR) FilePath);
	WritePrivateProfileString(_T("Information")		, _T("WDT Timer")		,	WDT_timer	, (LPCTSTR) FilePath);
}

void CF75111_DIODlg::FileOpen(CString FilePath)
{
	CString bAddress, WDT_timer, bLoop, bPermanent;
	GetPrivateProfileString(_T("Information"), _T("F75111 Address") , _T(""), bAddress	.GetBuffer(256), 256, FilePath);
	GetPrivateProfileString(_T("Information"), _T("WDT Timer")		, _T(""), WDT_timer .GetBuffer(256), 256, FilePath);

	SetDlgItemText(IDC_EDIT_ADDRESS ,bAddress);
	SetDlgItemText(IDC_WDT_TIMER ,WDT_timer);

	GetPrivateProfileString(_T("Permanent"), _T("WDT Loop")   , _T(""), bLoop.GetBuffer(256), 256, FilePath);

	if (atoi(bLoop) == 1 )
	{
		m_IsWDTLoop = TRUE;
		m_CHECK_EnableLoop.SetCheck(1);
		OnEnableWdt();
	}

	GetPrivateProfileString(_T("Permanent"), _T("Install")   , _T(""), bPermanent.GetBuffer(256), 256, FilePath);

	if (atoi(bPermanent) == 1 )
	{
		m_IsPermanent = TRUE;
		m_CHECK_PermanentWDT.SetCheck(1);
	}
}


